import gtk
import gobject
import vminstall.caps
import vminstall.msg
import vminstall.log
from tree_view import *


class HostDevicesView(PyTreeView):
    def __init__(self, host_devices):
        def column_toggled(cell, path, user_data):
            model, host_devices = user_data
            # Get the toggled iter and value from the column 0 checkbox
            iter = model.get_iter((int(path),))
            value = model.get_value(iter, 2)
            # Toggle the value
            value = not value
            # Set the new value in the wiget
            model.set(iter, 2, value)
        self._pyobj_index = 4
        self.model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING,
                                   gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
        self.view = gtk.TreeView(self.model)
        column = gtk.TreeViewColumn(vminstall.msg.name, gtk.CellRendererText(), text=0)
        self.view.append_column(column)
        column = gtk.TreeViewColumn(vminstall.msg.type, gtk.CellRendererText(), text=1)
        self.view.append_column(column)
        cr_toggle = gtk.CellRendererToggle()
        cr_toggle.connect('toggled', column_toggled, (self.model, host_devices))
        column = gtk.TreeViewColumn(vminstall.msg.managed, cr_toggle, active=2)
        self.view.append_column(column)
        column = gtk.TreeViewColumn(vminstall.msg.description, gtk.CellRendererText(), text=3)
        self.view.append_column(column)
        self.view.set_expander_column(column)
        self.view.set_search_column(3)
        self.set(host_devices)
        #if vminstall.caps.is_xen():
        #    cr_toggle.set_activatable(False)

    def _populate_row(self, iter, host_device):
        vminstall.log.debug("Adding row to host device table: '%s'" % host_device)
        host_device.number = self.model.get_path(iter)[0] + 1
        self.model.set(iter, 0, str(host_device.number), 1, host_device.type, 2, host_device.managed, 3, host_device.description, 4, host_device)

    def get(self):
        host_devices = PyTreeView.get(self)
        host_devices.sort(lambda n1,n2: cmp(n1.number, n2.number))
        return host_devices
