import gtk
import gobject
import vminstall.msg
import vminstall.log
from tree_view import *


class NicsView(PyTreeView):
    def __init__(self, nics):
        self._pyobj_index = 4
        self.model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING,
                                   gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
        self.view = gtk.TreeView(self.model)
        column = gtk.TreeViewColumn(vminstall.msg.name, gtk.CellRendererText(), text=0)
        self.view.append_column(column)
        column = gtk.TreeViewColumn(vminstall.msg.type, gtk.CellRendererText(), text=1)
        self.view.append_column(column)
        column = gtk.TreeViewColumn(vminstall.msg.source, gtk.CellRendererText(), text=2)
        self.view.append_column(column)
        column = gtk.TreeViewColumn(vminstall.msg.mac_address, gtk.CellRendererText(), text=3)
        self.view.append_column(column)
        self.view.set_expander_column(column)
        self.set(nics)

    def _populate_row(self, iter, nic):
        vminstall.log.debug("Adding row to nic table: '%s'" % nic)
        nic.number = self.model.get_path(iter)[0] + 1
        bridge = nic.bridge
        if bridge is None:
            bridge = vminstall.msg.default
        mac = nic.mac
        if mac is None:
            mac = vminstall.msg.random
        self.model.set(iter, 0, str(nic.number), 1, nic.model, 2, bridge, 3, mac, 4, nic)

    def get(self):
        nics = PyTreeView.get(self)
        nics.sort(lambda n1,n2: cmp(n1.number, n2.number))
        return nics
